<?php
/*
This file is part of TorrentParse.

    TorrentParse is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    TorrentParse is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TorrentParse; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    TorrentParse. TorrentParse parses bittorrent torrent files in PHP for use in web sites.
    Copyright (C) 2004 TorrentNews.tk

System Requirements:
PHP 4.*.* with sha1 function
Written on PHP 4.3.4
Untested on any other version

This code is not designed to give the smallest filesize, operate as fast as possible.
It is designed so as little can go wrong as possible, which to me is the most important thing.
This can be cleaned up a lot and made faster too
Based on BEncode, BDecode from PHPBTTRACKER.
Uses code snippets from DUMPTORRENTCGI.PHP.
PHPBTTRACKER is licenced under the GPL
Each term has been assigned a variable so that it can be used for further processing

CHANGES
Many more torrent variables added (mostly TorrentAid hashes)
"File cannot be found error", "File cannot be opened" and "File not Valid" errors added
function checkarray() added to reduce the amount of if((isset))s.
Name changed to "Internal File name" to reduce confusion

*/
// Errors are off because of unnecessary notice errors when torrent does not have extra variables
error_reporting  (E_ERROR | E_WARNING | E_PARSE);

require "./BDecode.php" ;
require "./BEncode.php" ;

// Checks to see that a torrent name is in GET
if (isset($_GET['filename']))  {
      /*     For DEBUG ONLY
      echo "Name of String in GET: ";
    echo $torrentname ;  echo "<BR>";
                                  */
                                  $torrentname = $_GET['filename'];
                                  // Opens torrent using binary
                                  // Change folder name here if desired
                                  $fd = fopen("./torrents/$torrentname", "rb") or die ("File not Found");
        $stream = fread($fd, filesize("./torrents/$torrentname")) or die("File Cannot be opened");
        fclose($fd);
        /* DEBUG USE
            echo "<pre>";
var_dump($array);
echo "</pre>";
*/
// This function checks for terms that are sometimes in a torrent and sometimes not depending on the creator program
 function checkarray($term, $description){
        if (isset ($term)) {

        echo $description ;
                echo $term ;
                  }
                             }
                         $array = BDecode($stream) or die("File ($torrentname) not valid");
          echo "Torrent Name: " ;
          echo $torrentname ;
          // Torrent Tracker
              echo "<BR>Torrent Announce URL: ";
        $announce = $array["announce"];
        echo $announce;
                             if (isset($array["announce-list"])){
                echo "<BR>This Torrent also has several backup trackers " ;
              // Loops through the list of Backup Trackers
                foreach ($array["announce-list"] as $alist)
                {
                echo "<BR>Tracker: " ;
                echo $alist[0] ;
                          }
                }

        // Stores 2D array as variable. The whole of $array['info'] is now called as $infovariable
        $infovariable = $array["info"];
             // Calculates SHA1 Hash
                      echo "<BR>Torrent Info Hash: ";
      $infohash = @sha1(BEncode($infovariable));
      echo $infohash ;
            //Calculates EDonkey2000 hash (ED2K) if present
      if (isset($infovariable["ed2k"])){
              $ed2k = $infovariable["ed2k"];
              $hexed2k = bin2hex($ed2k);
              echo "<BR>Edonkey2000 Hash: ";
              echo $hexed2k ;
                            }
            // Prints MD5SUM if present
      print $md5sum = checkarray($infovariable["md5sum"], "<BR>Torrent MD5SUM: ");
        if (isset($infovariable['sha1'])){
                echo "<BR>SHA1 Hash: " ;
                $hexsha1 = bin2hex($infovariable["sha1"]);
                echo $hexsha1 ;
                }
      // Calculates date from UNIX Epoch
      echo "<BR>Torrent Creation Date: ";
   echo $makedate = date('r' , $array["creation date"]);
   // The name of the torrent is different to the file name
   echo "<BR> Internal Filename of Torrent: ";
   $internalname = $infovariable['name'];
   echo $internalname ;
if (isset($infovariable['files']))  {
echo "<BR>This is a Multifile Torrent<BR>" ;
      foreach ($infovariable["files"] as $file)
                        {
                        // Loops through multifile torrent names
                                 echo "<BR>File Name: " ;
                         $multiname = $file['path'];
                         echo $multiname[0] ;
                                                    echo ". File Size: " ;
   $torrentsize = $file['length'] / 1024;
   echo round($torrentsize, 2) ;
   echo "KB" ;
     if (isset($file["ed2k"])) {
     echo "<BR>Edonkey2000 Hash: ";
             $multied2k = bin2hex($file["ed2k"]);
             echo $multied2k ;
                         }
             if (isset($file["sha1"])) {
              echo "<BR>SHA1 Hash: ";
             $multisha1 = bin2hex($file["sha1"]);
             echo $multisha1 ;

                        }
                         if (isset($file["MD5SUM"])) {
              echo "<BR>MD5SUM: ";
             $multimd5 = bin2hex($file["MD5SUM"]);
             echo $multimd5 ;


                        }
                        echo "<BR>";
                        }
        }
        else {
        // Calculates File size in KB and rounds to 2 decimal places
       echo "<BR> File Size: " ;
   $torrentsize = $infovariable['length'] / 1024;
   echo round($torrentsize, 2) ;
   echo "KB" ;
        }
   // Calculates Piece Size in KB
   echo "<BR>Piece Size: ";
   $piecesize = $infovariable['piece length'] / 1024;
   echo $piecesize ;
   echo "KB" ;

   // For terms that are only included in certain torrent files (Mostly TorrentAid)

 print $comment = checkarray($array["comment"], "<BR>Torrent Comment: ");
  print $created = checkarray($array["created by"], "<BR>Torrent Created By: ");
  print $encoding = checkarray($array["encoding"], "<BR>Torrent Encoding: ");
  print $usragent = checkarray($array["user-agent"], "<BR>Torrent File Creator: ");
  // doesn't seem to work without print even though it is not needed

                }
                else {
                           echo "No torrent name has been specified";
                }

?>